DECLARE SUB GMDSave (File$)
DECLARE SUB GMDLoadAMD (File$, Table$)

DECLARE SUB SplitCMD (file1$, file2$, file3$)

'$INCLUDE: 'MIDI.BI'

TYPE GMDHeader
  ID AS STRING * 4
  Tpe AS INTEGER
  Tracks AS INTEGER
  Tempo AS STRING * 1
  Seq AS STRING * 256
 
END TYPE

TYPE TRKHeader
  ID AS STRING * 4

END TYPE

TYPE Current
  Note AS INTEGER
  Track AS INTEGER

END TYPE

TYPE AMDHeader
  SongName AS STRING * 24
  AuthName AS STRING * 24
  InstT AS STRING * 884
  SongLen AS STRING * 1
  PatNum AS STRING * 1
  Seq AS STRING * 128
  ID AS STRING * 9
  Ver AS STRING * 1

END TYPE

' The GMD Music
' =-=-=-=-=-=-=
REDIM SHARED Track(19, 63) AS STRING * 48
DIM SHARED Current AS Current
DIM SHARED GMDHeader AS GMDHeader
DIM SHARED TRKHeader AS TRKHeader
DIM SHARED Handle AS INTEGER

' The AMD Music
' =-=-=-=-=-=-=
DIM SHARED AMDHeader AS AMDHeader
REDIM SHARED Pattern(36, 63) AS STRING * 27
REDIM SHARED InstC%(127)

IF INSTR(COMMAND$, "/?") THEN
  PRINT
  PRINT "G-Tech AMD 2 GMD Converter 2001 (C)"
  PRINT
  PRINT "Instrument Conversion Tables:"
  PRINT "    A plain text file with a list of numbers, the numbers"
  PRINT "being General MIDI Instrument Patches."
  PRINT

ELSEIF LTRIM$(RTRIM$(COMMAND$)) = "" THEN
  PRINT
  PRINT "G-Tech AMD 2 GMD Converter 2001 (C)"
  PRINT
  PRINT "Format:"
  PRINT "       AMD2GMD [AMD] [GMD] [TAB]"
  PRINT
  PRINT "Key:"
  PRINT "       [AMD] - The AMD File to Convert"
  PRINT "       [GMD] - The GMD File to Save"
  PRINT "       [TAB] - The Instrument Conversion Tables"
  PRINT
ELSEIF LTRIM$(RTRIM$(COMMAND$)) <> "" THEN
  PRINT
  PRINT "G-Tech AMD 2 GMD Converter 2001 (C)"
  PRINT
  SplitCMD a$, b$, c$
  PRINT "Importing AMD...";
  GMDLoadAMD a$, c$
  PRINT "Done!"
  PRINT "Saving GMD...";
  GMDSave b$
  PRINT "Done!"
  PRINT

END IF

SUB GMDLoadAMD (File$, Table$)
  Handle = FREEFILE
  GMDHeader.Tempo = CHR$(18)
  GMDHeader.Tracks = 19

  OPEN Table$ FOR APPEND AS #1: CLOSE #1
  OPEN Table$ FOR INPUT AS #1
    DO
      INPUT #1, InstC%(c%)
      c% = c% + 1
    LOOP UNTIL EOF(1)
  CLOSE #1

  OPEN File$ FOR BINARY AS Handle
    GET Handle, , AMDHeader

    GMDHeader.Tempo = CHR$(18)
    GMDHeader.Tracks = 19
    GMDHeader.Seq = STRING$(256, CHR$(255))
    GMDHeader.Seq = AMDHeader.Seq

    IF ASC(AMDHeader.Ver) = &H10 THEN                   ' Normal
      FOR i = 0 TO ASC(AMDHeader.PatNum) - 1
        FOR j = 0 TO 63
          GET Handle, , Pattern(i, j)
        NEXT
      NEXT
    ELSE                                                ' Packed
       GOTO Endd:
    END IF

    FOR i = 0 TO ASC(AMDHeader.PatNum) - 1
      FOR j = 0 TO 63
        Track(i, j) = STRING$(48, " ")
        FOR k = 0 TO 8
          O% = k * 3
          X% = ASC(MID$(Pattern(i, j), O% + 3, 1))
          Y% = ASC(MID$(Pattern(i, j), O% + 2, 1))
          Z% = ASC(MID$(Pattern(i, j), O% + 1, 1))

          Pitch% = ((X% AND 240) \ (2 ^ 4))
          Oct% = ((X% AND 14) \ (2 ^ 1))
          Inst% = (((X% AND 1)) + ((Y% AND 240) \ (2 ^ 4)))
          Event% = ((Y% AND 15))
          Param% = ((Z% AND 254) \ (2 ^ 1))
          BitPack% = ((Z% AND 1))

          IF Pitch% > 11 THEN Pitch% = 11
          Note% = (Oct% * 12) + Pitch%

          Cmd% = 0
          IF Note% > 0 AND Note% <= 127 THEN Cmd% = &HB
          IF Event% = &H6 THEN Cmd% = &HA
          IF Event% = &H4 THEN Cmd% = &H10 + (Param% \ 4)
          Inst% = Inst% - 1
          IF Inst% < 0 THEN Inst% = 0


          Inst% = InstC%(Inst%)

          Track(i, j) = LTRIM$(RTRIM$(Track(i, j))) + CHR$(Cmd%) + CHR$(Note%) + CHR$(Inst%)
         
        NEXT

      NEXT
    NEXT
Endd:
  CLOSE Handle
  
END SUB

SUB GMDSave (File$)
  Handle = FREEFILE
  OPEN File$ FOR BINARY AS Handle
    PUT Handle, , GMDHeader
    FOR i = 0 TO GMDHeader.Tracks
      PUT Handle, , TRKHeader
      FOR j = 0 TO 63
        PUT Handle, , Track(i, j)
      NEXT
    NEXT

  CLOSE Handle

END SUB

SUB SplitCMD (file1$, file2$, file3$)
  Cmd$ = COMMAND$
 
  f1% = INSTR(Cmd$, " ") - 1
  file1$ = LEFT$(Cmd$, f1%)
  Cmd$ = RIGHT$(Cmd$, LEN(Cmd$) - LEN(file1$))

  f2% = INSTR(Cmd$, " ") + LEN(file1$)
  file2$ = RTRIM$(LTRIM$(LEFT$(Cmd$, f2%)))
  Cmd$ = RIGHT$(Cmd$, LEN(Cmd$) - LEN(file2$) - 1)

  file3$ = RTRIM$(LTRIM$(Cmd$))
END SUB

