DECLARE SUB GMDPlay ()
DECLARE SUB GMDLoad (File$)

'$INCLUDE: 'MIDI.BI'

TYPE GMDHeader
  ID AS STRING * 4
  Tpe AS INTEGER
  Tracks AS INTEGER
  Tempo AS STRING * 1
  Seq AS STRING * 256
 
END TYPE

TYPE TRKHeader
  ID AS STRING * 4

END TYPE

TYPE Current
  Note AS INTEGER
  Track AS INTEGER

END TYPE

' The GMD Music
' =-=-=-=-=-=-=
REDIM SHARED Track(19, 63) AS STRING * 48
DIM SHARED Current AS Current
DIM SHARED GMDHeader AS GMDHeader
DIM SHARED TRKHeader AS TRKHeader
DIM SHARED Handle AS INTEGER

MIDIInit &H330


SCREEN 0
COLOR 7, 0
CLS
PRINT "MIDI Lib MPU GMD Format Demo V1.0"
PRINT "================================="
PRINT
PRINT " 1) The NEO Intro, a song by the makers of the"
PRINT "    HSC Format."
PRINT " 2) A song I got with AdLib for Winamp, very good!"
PRINT
PRINT "Choose: ";
INPUT "", a$
GMDLoad "neointro.gmd"
IF a$ = "1" THEN GMDLoad "neointro.gmd"
IF a$ = "2" THEN GMDLoad "thecom.gmd"

COLOR 15, 1
CLS
DO
  IF TIMER - ST# > 1 / (ASC(GMDHeader.Tempo) + .2) THEN
    ST# = TIMER
    GMDPlay
  END IF
  LOCATE 1, 1
  T% = ASC(MID$(GMDHeader.Seq, Current.Track + 1, 1))
  PRINT "Current Track:"; T%; "   Current Note:"; Current.Note
  PRINT
  PRINT "ͻ"
  PRINT " 0   1   2   3   4   5   6   7   8   9   10  11  12  13  14  15"
  PRINT "͹"

  FOR j = -8 TO 8
    PRINT "";
    FOR i = 0 TO 15
      i% = Current.Note - j
      IF i% < 0 THEN Note% = 0: GOTO SkipNote:
      IF i% > 63 THEN Note% = 0: GOTO SkipNote:
      IF T% > 19 THEN T% = 19
      Note% = (ASC(MID$(Track(T%, i%), i * 3 + 2, 1)))
      Oct% = Note% \ 12
      Note% = Note% MOD 12 + 1
      N% = Note%

      Cmd% = (ASC(MID$(Track(T%, i%), i * 3 + 1, 1)))
SkipNote:
      a$ = ""
      Note% = Note% - 1
      IF Cmd% = &HB OR Cmd% >= &H10 AND Cmd% <= &H1F THEN
        IF Note% = 1 THEN a$ = "C-" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 2 THEN a$ = "C#" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 3 THEN a$ = "D-" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 4 THEN a$ = "D#" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 5 THEN a$ = "E-" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 6 THEN a$ = "F-" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 7 THEN a$ = "F#" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 8 THEN a$ = "G-" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 9 THEN a$ = "G#" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 10 THEN a$ = "A-" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 11 THEN a$ = "A#" + LTRIM$(RTRIM$(STR$(Oct%)))
        IF Note% = 12 THEN a$ = "B-" + LTRIM$(RTRIM$(STR$(Oct%)))

      ELSE
        IF Cmd% = &HA THEN a$ = "SKP"
        IF Cmd% = &HB THEN a$ = "ON "
        IF Cmd% = &HC THEN a$ = "OFF"

      END IF

      IF LEN(a$) = 2 THEN a$ = " " + a$
      IF LEN(a$) = 1 THEN a$ = "  " + a$
      IF LEN(a$) = 0 THEN a$ = "   "
      IF j = 0 THEN COLOR 4, 2
      PRINT a$;
      IF j = 0 THEN COLOR 15, 2
      PRINT "";
      COLOR 15, 1

    NEXT
    PRINT
  NEXT
  PRINT "ͼ"

LOOP UNTIL INKEY$ = CHR$(27)
FOR i = 0 TO 15
  FOR j = 0 TO 127
    MIDINote j, 0, i
    MIDINoteOff j, 0, i
  NEXT
NEXT

MIDIReset
SCREEN 0
COLOR 7, 0
CLS

SUB GMDLoad (File$)
  Handle = FREEFILE
  OPEN File$ FOR BINARY AS Handle
    GET Handle, , GMDHeader
    FOR i = 0 TO GMDHeader.Tracks
      GET Handle, , TRKHeader
      FOR j = 0 TO 63
        GET Handle, , Track(i, j)
      NEXT
    NEXT

  CLOSE Handle
END SUB

SUB GMDPlay
 
  T% = ASC(MID$(GMDHeader.Seq, Current.Track + 1, 1))
  IF T% = 255 THEN
    Current.Track = 0
    T% = ASC(MID$(GMDHeader.Seq, Current.Track + 1, 1))
  END IF

  FOR i% = 0 TO 4
   
    ' Decode a Command
    ' ================
    c% = (i% * 3) + 1
    Cmd$ = MID$(Track(T%, Current.Note), c%, 1)
    Dta$ = MID$(Track(T%, Current.Note), c% + 1, 1)
    Ins$ = MID$(Track(T%, Current.Note), c% + 2, 1)
    
    ' Change the Instrument if needed
    ' ===============================
    IF ASC(Ins$) <> 255 THEN MIDIInstrument i%, ASC(Ins$)

    ' Now Carry out the Command
    ' =========================
   
    c% = ASC(Cmd$)

    SELECT CASE c%
      CASE &HA
        IF ASC(Dta$) = 0 THEN
          Current.Note = -1
          Current.Track = Current.Track + 1
          GOTO EndRow:
        END IF

      CASE &HB
        Note% = ASC(Dta$)
        Note% = Note% + 12
        MIDINote Note%, 64, i%
     
      CASE &HC
        Note% = ASC(Dta$)
        Note% = Note% + 12
        MIDINoteOff Note%, 0, i%


    END SELECT
    IF c% >= &H10 AND c% <= &H1F THEN
      Note% = ASC(Dta$)
      Note% = Note% + 12
      MIDINote Note%, 64, i%

    END IF
   
  NEXT

EndRow:
  Current.Note = Current.Note + 1
  IF Current.Note = 64 THEN
    Current.Note = 0
    Current.Track = Current.Track + 1
  END IF

END SUB

