DECLARE SUB GMDSave (File$)
DECLARE SUB GMDLoadHSC (File$, Table$)

DECLARE SUB SplitCMD (file1$, file2$, file3$)

'$INCLUDE: 'MIDI.BI'

TYPE GMDHeader
  ID AS STRING * 4
  Tpe AS INTEGER
  Tracks AS INTEGER
  Tempo AS STRING * 1
  Seq AS STRING * 256
 
END TYPE

TYPE TRKHeader
  ID AS STRING * 4

END TYPE

TYPE Current
  Note AS INTEGER
  Track AS INTEGER

END TYPE

' The GMD Music
' =-=-=-=-=-=-=
REDIM SHARED Track(19, 63) AS STRING * 48
DIM SHARED Current AS Current
DIM SHARED GMDHeader AS GMDHeader
DIM SHARED TRKHeader AS TRKHeader
DIM SHARED Handle AS INTEGER

' The HSC Music
' =-=-=-=-=-=-=
DIM SHARED Inst  AS STRING * 1536
REDIM SHARED Notes(49, 63)  AS STRING * 18
DIM SHARED Pats AS STRING * 51
REDIM SHARED InstC(127) AS INTEGER
REDIM SHARED InstN%(15)

IF INSTR(COMMAND$, "/?") THEN
  PRINT
  PRINT "G-Tech HSC 2 GMD Converter 2001 (C)"
  PRINT
  PRINT "Instrument Conversion Tables:"
  PRINT "    A plain text file with a list of numbers, the numbers"
  PRINT "being General MIDI Instrument Patches."
  PRINT

ELSEIF LTRIM$(RTRIM$(COMMAND$)) = "" THEN
  PRINT
  PRINT "G-Tech HSC 2 GMD Converter 2001 (C)"
  PRINT
  PRINT "Format:"
  PRINT "       HSC2GMD [HSC] [GMD] [TAB]"
  PRINT
  PRINT "Key:"
  PRINT "       [HSC] - The HSC File to Convert"
  PRINT "       [GMD] - The GMD File to Save"
  PRINT "       [TAB] - The Instrument Conversion Tables"
  PRINT
ELSEIF LTRIM$(RTRIM$(COMMAND$)) <> "" THEN
  PRINT
  PRINT "G-Tech HSC 2 GMD Converter 2001 (C)"
  PRINT
  SplitCMD a$, b$, c$
  PRINT "Importing HSC...";
  GMDLoadHSC a$, c$
  PRINT "Done!"
  PRINT "Saving GMD...";
  GMDSave b$
  PRINT "Done!"
  PRINT

END IF

SUB GMDLoadHSC (File$, Table$)
  Handle = FREEFILE
  GMDHeader.Tempo = CHR$(18)
  GMDHeader.Tracks = 19

  OPEN Table$ FOR APPEND AS #1: CLOSE #1
  OPEN Table$ FOR INPUT AS #1
    DO
      INPUT #1, InstC%(c%)
      c% = c% + 1
    LOOP UNTIL EOF(1)
  CLOSE #1
  OPEN File$ FOR BINARY AS Handle
    GET Handle, , Inst
    FOR i = 0 TO 15
      InstN%(i) = InstC%(i)
    NEXT
    GET Handle, , Pats
    GMDHeader.Seq = Pats
    FOR i = 0 TO 19
      FOR j = 0 TO 63
        GET Handle, , Notes(i, j)
        Track(i, j) = STRING$(255, " ")

        HSCNum% = 1
        Chan% = 0
        FOR k = 1 TO 27 STEP 3
          Note$ = MID$(Notes(i, j), HSCNum%, 1)
          IF Note$ = "" THEN Note$ = CHR$(0)
          Note% = ASC(Note$)
          Opt$ = MID$(Notes(i, j), HSCNum% + 1, 1)
          IF Opt$ = "" THEN Opt$ = CHR$(0)
          Opt% = ASC(Opt$)

          N% = (Note% - 1) MOD 12
          Opt$ = CHR$(&HFF)
          IF Note% AND 128 THEN
            InstN%(Chan%) = InstC%(Opt%)
          END IF
         
          IF Opt% = &H1 AND Note% = 0 THEN Opt$ = CHR$(&HA)             ' Skip Track

          IF Note% > 0 AND Note% < 127 THEN Opt$ = CHR$(&HB)            ' Play Note

          IF Opt% >= &H30 AND Opt% <= &H5F THEN
            InstN%(Chan%) = InstC%(Opt% - &H30)
          END IF
         
          IF Opt% >= &HC0 AND Opt% <= &HCF THEN
            Opt$ = CHR$(&H10 + (Opt% AND 15))
          END IF
          

          Track(i, j) = RTRIM$(Track(i, j)) + Opt$ + Note$ + CHR$(InstN%(Chan%))

          HSCNum% = HSCNum% + 2
          Chan% = Chan% + 1

        NEXT
      NEXT
    NEXT
  CLOSE Handle
  
END SUB

SUB GMDSave (File$)
  Handle = FREEFILE
  OPEN File$ FOR BINARY AS Handle
    PUT Handle, , GMDHeader
    FOR i = 0 TO GMDHeader.Tracks
      PUT Handle, , TRKHeader
      FOR j = 0 TO 63
        PUT Handle, , Track(i, j)
      NEXT
    NEXT

  CLOSE Handle

END SUB

SUB SplitCMD (file1$, file2$, file3$)
  CMD$ = COMMAND$
 
  f1% = INSTR(CMD$, " ") - 1
  file1$ = LEFT$(CMD$, f1%)
  CMD$ = RIGHT$(CMD$, LEN(CMD$) - LEN(file1$))

  f2% = INSTR(CMD$, " ") + LEN(file1$)
  file2$ = RTRIM$(LTRIM$(LEFT$(CMD$, f2%)))
  CMD$ = RIGHT$(CMD$, LEN(CMD$) - LEN(file2$) - 1)

  file3$ = RTRIM$(LTRIM$(CMD$))
END SUB

